module DraftApprove
  module Serialization
    module Json
      # Constants defining the keys used to point to associations when
      # serializing draft changes.
      #
      # These work in a similar manner to how ActiveRecord polymorphic
      # associations work, defining the type / class of the associated object,
      # and it's id.
      #
      # IMPORTANT NOTE: These constants are written to the database, so cannot
      # be updated without requiring a migration of existing draft data. Such a
      # migration may be very slow, since these constants are embedded in the
      # JSON generated by this serializer!
      module Constants
        TYPE = 'type'.freeze
        ID = 'id'.freeze
      end
    end
  end
end
